=== lldb/unittests/Utility/CMakeLists.txt ===
add_lldb_unittest(UtilityTests
  AnsiTerminalTest.cpp
  ArgsTest.cpp
  OptionsWithRawTest.cpp
  ArchSpecTest.cpp
  BroadcasterTest.cpp
  ChecksumTest.cpp
  ConstStringTest.cpp
  CompletionRequestTest.cpp
  DataBufferTest.cpp
  DataEncoderTest.cpp
  DataExtractorTest.cpp
  EnvironmentTest.cpp
  EventTest.cpp
  FileSpecListTest.cpp
  FileSpecTest.cpp
  FlagsTest.cpp
  ListenerTest.cpp
  LogTest.cpp
  NameMatchesTest.cpp
  NonNullSharedPtrTest.cpp
  PredicateTest.cpp
  ProcessInfoTest.cpp
  ProcessInstanceInfoTest.cpp
  RangeMapTest.cpp
  RangeTest.cpp
  RealpathPrefixesTest.cpp
  RegisterValueTest.cpp
  RegularExpressionTest.cpp
  ScalarTest.cpp
  SharedClusterTest.cpp
  StateTest.cpp
  StatusTest.cpp
  StreamTeeTest.cpp
  StreamTest.cpp
  StringExtractorGDBRemoteTest.cpp
  StringExtractorTest.cpp
  StringListTest.cpp
  StructuredDataTest.cpp
  SubsystemRAIITest.cpp
  SupportFileTest.cpp
  TildeExpressionResolverTest.cpp
  TimeoutTest.cpp
  TimerTest.cpp
  TraceGDBRemotePacketsTest.cpp
  UriParserTest.cpp
  UserIDResolverTest.cpp
  UUIDTest.cpp
  VASprintfTest.cpp
  VirtualDataExtractorTest.cpp
  VMRangeTest.cpp
  XcodeSDKTest.cpp

  LINK_COMPONENTS
    Support
    TargetParser
  LINK_LIBS
      lldbUtility
      lldbUtilityHelpers
      LLVMTestingSupport
  )

set(test_inputs
  StructuredData-basic.json
  StructuredData-nested.json
  StructuredData-full.json
  )

add_unittest_inputs(UtilityTests "${test_inputs}")
