=== debian/changelog ===
llvm-toolchain-3.4 (1:3.4~+rc3-1ubuntu4) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec
